<!--
    Copyright © 2016 - 2020 Stefan Berg <isbeorn86+NINA@googlemail.com> and the N.I.N.A. contributors 

    This file is part of N.I.N.A. - Nighttime Imaging 'N' Astronomy.

    This Source Code Form is subject to the terms of the Mozilla Public
    License, v. 2.0. If a copy of the MPL was not distributed with this
    file, You can obtain one at http://mozilla.org/MPL/2.0/.
-->
<UserControl
    x:Class="NINA.View.PolarAlignmentView"
    xmlns="http://schemas.microsoft.com/winfx/2006/xaml/presentation"
    xmlns:x="http://schemas.microsoft.com/winfx/2006/xaml"
    xmlns:astrometry="clr-namespace:NINA.Utility.Astrometry"
    xmlns:d="http://schemas.microsoft.com/expression/blend/2008"
    xmlns:local="clr-namespace:NINA.View"
    xmlns:mc="http://schemas.openxmlformats.org/markup-compatibility/2006"
    xmlns:ninactrl="clr-namespace:NINACustomControlLibrary;assembly=NINACustomControlLibrary"
    xmlns:rules="clr-namespace:NINA.Utility.ValidationRules"
    xmlns:util="clr-namespace:NINA.Utility"
    d:DesignHeight="300"
    d:DesignWidth="400"
    mc:Ignorable="d">
    <Grid IsEnabled="{Binding TelescopeInfo, Converter={StaticResource InverseNullToBooleanConverter}}">
        <Border
            HorizontalAlignment="Center"
            VerticalAlignment="Center"
            Panel.ZIndex="99"
            Background="{StaticResource BackgroundBrush}"
            BorderBrush="{StaticResource BorderBrush}"
            BorderThickness="1"
            Visibility="{Binding TelescopeInfo.Connected, Converter={StaticResource InverseBoolToVisibilityConverter}}">
            <TextBlock FontSize="40">
                Please connect Telescope
            </TextBlock>
        </Border>
        <Grid IsEnabled="{Binding TelescopeInfo.Connected}">
            <Grid.ColumnDefinitions>
                <ColumnDefinition />
                <ColumnDefinition />
            </Grid.ColumnDefinitions>
            <Grid.RowDefinitions>
                <RowDefinition />
                <RowDefinition Height="5" />
                <RowDefinition />
            </Grid.RowDefinitions>
            <GroupBox Header="Polar Scope">
                <local:PolarScopeView />
            </GroupBox>

            <GroupBox Grid.Column="1" Header="Plate Solved PA">
                <Grid>
                    <Grid.RowDefinitions>
                        <RowDefinition Height="1*" />
                        <RowDefinition Height="40" />
                        <RowDefinition Height="3*" />
                        <RowDefinition Height="3*" />
                    </Grid.RowDefinitions>
                    <Grid Grid.Row="0">
                        <Grid.ColumnDefinitions>
                            <ColumnDefinition />
                            <ColumnDefinition />
                            <ColumnDefinition Width="50" />
                        </Grid.ColumnDefinitions>
                        <StackPanel Grid.Column="0">
                            <TextBlock>Meridian Offset:</TextBlock>
                            <TextBox Margin="0,0,10,0" Text="{Binding MeridianOffset}" />
                        </StackPanel>
                        <StackPanel Grid.Column="1">
                            <TextBlock>Declination:</TextBlock>
                            <TextBox Margin="0,0,10,0" Text="{Binding Declination}" />
                        </StackPanel>

                        <Button
                            Grid.Column="2"
                            Height="30"
                            Margin="0,10,0,0"
                            HorizontalAlignment="Stretch"
                            VerticalAlignment="Top"
                            Command="{Binding SlewToMeridianOffsetCommand}">
                            <TextBlock
                                VerticalAlignment="Center"
                                Foreground="{StaticResource ButtonForegroundBrush}"
                                Text="Slew" />
                        </Button>
                    </Grid>

                    <Grid
                        Grid.Row="1"
                        HorizontalAlignment="Left"
                        IsEnabled="{Binding Cam, Converter={StaticResource InverseNullToBooleanConverter}}">
                        <local:CameraControlView
                            IsEnabled="{Binding CameraInfo.Connected}"
                            MyBinningModes="{Binding Source={StaticResource AppVM}, Path=CameraVM.Cam.BinningModes, Mode=TwoWay}"
                            MyExposureDuration="{Binding SnapExposureDuration, Mode=TwoWay}"
                            MyFilters="{Binding Source={StaticResource AppVM}, Path=ActiveProfile.FilterWheelSettings.FilterWheelFilters}"
                            MySelectedBinningMode="{Binding SnapBin, Mode=TwoWay}"
                            MySelectedFilter="{Binding SnapFilter, Mode=TwoWay}" />
                    </Grid>

                    <GroupBox Grid.Row="2" Header="Altitude Measurement">
                        <StackPanel Orientation="Vertical">
                            <TextBlock>Point telescope east or west. Adjust combobox value accordingly</TextBlock>
                            <StackPanel
                                Margin="0,10,0,0"
                                VerticalAlignment="Center"
                                Orientation="Horizontal">
                                <TextBlock VerticalAlignment="Center">Altitude measurement side:</TextBlock>
                                <ComboBox
                                    Margin="10,0,0,0"
                                    ItemsSource="{Binding Source={util:EnumBindingSource {x:Type astrometry:AltitudeSite}}}"
                                    SelectedItem="{Binding AltitudeSiteType}" />
                                <ninactrl:CancellableButton
                                    Width="40"
                                    Height="40"
                                    Margin="10,0,0,0"
                                    ButtonImage="{StaticResource ArrowTwoSidesRotated}"
                                    CancelButtonImage="{StaticResource CancelSVG}"
                                    CancelCommand="{Binding CancelMeasureAltitudeErrorCommand}"
                                    Command="{Binding MeasureAltitudeErrorCommand}"
                                    ToolTip="Measure Altitude Error&#10;Point Scope East or West and adjust Side of Pier combobox accordingly" />
                                <TextBlock
                                    Margin="10,0,0,0"
                                    VerticalAlignment="Center"
                                    Text="{Binding AltitudePolarErrorStatus}" />
                            </StackPanel>
                        </StackPanel>
                    </GroupBox>
                    <GroupBox Grid.Row="3" Header="Azimuth Measurement">
                        <StackPanel Orientation="Vertical">
                            <TextBlock>Point telescope near meridian.</TextBlock>
                            <StackPanel
                                Margin="0,10,0,0"
                                VerticalAlignment="Center"
                                Orientation="Horizontal">
                                <ninactrl:CancellableButton
                                    Width="40"
                                    Height="40"
                                    ButtonImage="{StaticResource ArrowTwoSides}"
                                    CancelButtonImage="{StaticResource CancelSVG}"
                                    CancelCommand="{Binding CancelMeasureAzimuthErrorCommand}"
                                    Command="{Binding MeasureAzimuthErrorCommand}"
                                    ToolTip="Measure Azimuth Error&#10;Point Scope South near Meridian" />
                                <TextBlock
                                    Margin="10,0,0,0"
                                    VerticalAlignment="Center"
                                    Text="{Binding AzimuthPolarErrorStatus}" />
                            </StackPanel>
                        </StackPanel>
                    </GroupBox>

                    <!--<TextBlock Text="{Binding PolarErrorStatus}" Grid.Row="3" />-->
                </Grid>
            </GroupBox>
            <GridSplitter
                Grid.Row="1"
                Grid.ColumnSpan="2"
                HorizontalAlignment="Stretch" />
            <GroupBox
                Grid.Row="2"
                Grid.ColumnSpan="2"
                Header="D.A.R.V. Alignment">
                <Grid>
                    <Grid.ColumnDefinitions>
                        <ColumnDefinition Width="*" />
                        <ColumnDefinition Width="140" />
                    </Grid.ColumnDefinitions>
                    <Grid>
                        <local:ImageControlView DataContext="{Binding Source={StaticResource AppVM}, Path=ImagingVM.ImageControl}" />
                    </Grid>
                    <Grid Grid.Column="1" Margin="5,0,0,0">
                        <Grid.RowDefinitions>
                            <RowDefinition />
                            <RowDefinition Height="60" />
                            <RowDefinition Height="30" />
                        </Grid.RowDefinitions>
                        <TextBlock TextWrapping="Wrap">Specify the duration for the D.A.R.V. procedure. The telescope will slew half the time in one direction on RA axis and then slew back.</TextBlock>
                        <StackPanel Grid.Column="1" VerticalAlignment="Bottom">

                            <TextBlock>Slew Rate (deg/sec)</TextBlock>
                            <TextBox>
                                <TextBox.Text>
                                    <Binding Path="DARVSlewRate" UpdateSourceTrigger="LostFocus">
                                        <Binding.ValidationRules>
                                            <rules:GreaterZeroRule />
                                        </Binding.ValidationRules>
                                    </Binding>
                                </TextBox.Text>
                            </TextBox>
                            <TextBlock>Slew Duration:</TextBlock>
                            <TextBox>
                                <TextBox.Text>
                                    <Binding Path="DARVSlewDuration" UpdateSourceTrigger="LostFocus">
                                        <Binding.ValidationRules>
                                            <rules:GreaterZeroRule />
                                        </Binding.ValidationRules>
                                    </Binding>
                                </TextBox.Text>
                            </TextBox>
                            <TextBlock Text="{Binding DarvStatus}" />
                        </StackPanel>

                        <ninactrl:CancellableButton
                            Grid.Row="1"
                            Height="30"
                            Margin="0,10,0,0"
                            ButtonText="Slew"
                            CancelButtonImage="{StaticResource CancelSVG}"
                            CancelCommand="{Binding CancelDARVSlewCommand}"
                            Command="{Binding DARVSlewCommand}"
                            ToolTip="This will take an exposure while slewing the scope slowly to one side and back&#10;when the lines are not aligned there is some PA error" />
                    </Grid>
                </Grid>
            </GroupBox>
            <Grid.Style>
                <Style TargetType="{x:Type Grid}">
                    <Style.Triggers>
                        <Trigger Property="IsEnabled" Value="false">
                            <Setter Property="Opacity" Value="0.6" />
                        </Trigger>
                    </Style.Triggers>
                </Style>
            </Grid.Style>
        </Grid>
    </Grid>
</UserControl>
